const {desktopCapturer} = require('electron');

function addSource(displayJqItem, source) {
    $(displayJqItem).append("'<img src='"+source.thumbnail.toDataURL()+"' class='desktopIcon' width='50' height='50' data-src-id='"+source.id+"' />");
}

function addDesktopShareSource(displayJqItem, source) {
    var html = "<div class='screenshareContainer'>" +
                  "'<img src='" + source.thumbnail.toDataURL() + "' class='desktopIcon' width='50' height='50' data-src-id='" + source.id+ "' />" +
                  "<div class='overlay'>" +
                      "<div class='overlayText'>Share the entire screen</div>" +
                  "</div>" +
               "</div>";
    $(displayJqItem).append(html);
}

function showSources(displayJqItem, callback) {
    $(displayJqItem).html("");
    desktopCapturer.getSources({ types:['window', 'screen'], thumbnailSize: {width: 700, height: 700} }, function(error, sources) {
        for(var i = 0; i < sources.length; i++) {
            var source = sources[i];
            console.log("Name: " + source.name);
            if(i == 0) {
                addDesktopShareSource(displayJqItem, source);
            } else {
                addSource(displayJqItem, source);
            }
        }
        if(callback) {
            callback();
        }
    });
}

window.onload = () => {
    console.log("window onload [Preload]====>>>");
    $(document).ready(function() {
        console.log("Document is ready [Preload]====>>>");
        window.interop = {
            handleScreenShare : function(displayJqItem, callback) {
                console.log("room page desktop sharing selection has changed");
                showSources(displayJqItem, callback);
            }
        };
    });
}
